## dolfin 2018.1.0.post1

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for DOLFIN

# Require CMake 3.5
cmake_minimum_required(VERSION 3.5)

#------------------------------------------------------------------------------
# Set project name and version number

project(DOLFIN)
set(DOLFIN_VERSION_RELEASE 1)
set(DOLFIN_VERSION_MAJOR "2018")
set(DOLFIN_VERSION_MINOR "1")
set(DOLFIN_VERSION_MICRO "0")
set(DOLFIN_VERSION "${DOLFIN_VERSION_MAJOR}.${DOLFIN_VERSION_MINOR}.${DOLFIN_VERSION_MICRO}")
if (NOT DOLFIN_VERSION_RELEASE)
  set(DOLFIN_VERSION "${DOLFIN_VERSION}.dev0")
endif()

#------------------------------------------------------------------------------
# Require and use C++11

# Use C++11
set(CMAKE_CXX_STANDARD 11)

# Require C++11
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Do not enable compler-specific extensions
set(CMAKE_CXX_EXTENSIONS OFF)

#------------------------------------------------------------------------------
# Check compiler version

# Check for GCC version - earlier versions have insuffcient C++11
# support, or bugs.
if (CMAKE_COMPILER_IS_GNUCXX)
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8.3)
    message(FATAL_ERROR "GCC version must be at least 4.8.3 (for sufficient C++11  support and to avoid some compiler bugs). You have version ${CMAKE_CXX_COMPILER_VERSION}")
  endif()
endif()

#------------------------------------------------------------------------------
# Get GIT changeset, if available

# Check for git
find_program(GIT_FOUND git)

if (GIT_FOUND)
  # Get the commit hash of the working branch
  execute_process(COMMAND git rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else()
  set(GIT_COMMIT_HASH "unknown")
endif()

#------------------------------------------------------------------------------
# General configuration

# Set CMake options, see `cmake --help-policy CMP000x`
if (COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0004 NEW)
  cmake_policy(SET CMP0042 NEW)
endif()

# Set location of our FindFoo.cmake modules
set(DOLFIN_CMAKE_DIR "${DOLFIN_SOURCE_DIR}/cmake" CACHE INTERNAL "")
set(CMAKE_MODULE_PATH "${DOLFIN_CMAKE_DIR}/modules")

# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfin)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFIN with shared libraries." ON)
option(CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects." OFF)
option(DOLFIN_AUTO_DETECT_MPI "Detect MPI automatically (turn this off to use the MPI compiler wrappers directly via setting CXX, CXX, FC)." ON)
option(DOLFIN_DEPRECATION_ERROR "Turn deprecation warnings into errors." OFF)
option(DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs." OFF)
option(DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage." OFF)
option(DOLFIN_ENABLE_DOCS "Enable generation of documentation." ON)
option(DOLFIN_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages." OFF)
option(DOLFIN_WITH_LIBRARY_VERSION "Build with library version information." ON)
option(DOLFIN_ENABLE_GEOMETRY_DEBUGGING "Enable geometry debugging (developers only; requires libcgal-dev and libcgal-qt5-dev)." OFF)

add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFIN with shared libraries.")
add_feature_info(CMAKE_USE_RELATIVE_PATHS CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects.")
add_feature_info(DOLFIN_AUTO_DETECT_MPI DOLFIN_AUTO_DETECT_MPI "Detect MPI automatically (turn this off to use the MPI compiler wrappers directly via setting CXX, CXX, FC).")
add_feature_info(DOLFIN_ENABLE_CODE_COVERAGE DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage.")
add_feature_info(DOLFIN_WITH_LIBRARY_VERSION DOLFIN_WITH_LIBRARY_VERSION "Build with library version information.")
add_feature_info(DOLFIN_ENABLE_BENCHMARKS DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs.")
add_feature_info(DOLFIN_ENABLE_DOCS DOLFIN_ENABLE_DOCS "Enable generation of documentation.")
add_feature_info(DOLFIN_SKIP_BUILD_TESTS DOLFIN_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages.")
add_feature_info(DOLFIN_DEPRECATION_ERROR DOLFIN_DEPRECATION_ERROR "Turn deprecation warnings into errors.")
add_feature_info(DOLFIN_ENABLE_GEOMETRY_DEBUGGING DOLFIN_ENABLE_GEOMETRY_DEBUGGING "Enable geometry debugging.")

# Add shared library paths so shared libs in non-system paths are found
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")

# Hande RPATH on OSX when not installing to a system directory, see
# https://groups.google.com/d/msg/fenics-dev/KSCrob4M_1M/zsJwdN-SCAAJ
# and https://cmake.org/Wiki/CMake_RPATH_handling#Always_full_RPATH.
if (APPLE)
  # The RPATH to be used when installing, but only if it's not a
  # system directory
  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
  IF("${isSystemDir}" STREQUAL "-1")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  ENDIF("${isSystemDir}" STREQUAL "-1")
endif()

#------------------------------------------------------------------------------
# Enable or disable optional packages

# List optional packages
set(OPTIONAL_PACKAGES "")
list(APPEND OPTIONAL_PACKAGES "MPI")
list(APPEND OPTIONAL_PACKAGES "PETSc")
list(APPEND OPTIONAL_PACKAGES "SLEPc")
list(APPEND OPTIONAL_PACKAGES "Trilinos")
list(APPEND OPTIONAL_PACKAGES "UMFPACK")
list(APPEND OPTIONAL_PACKAGES "CHOLMOD")
list(APPEND OPTIONAL_PACKAGES "SCOTCH")
list(APPEND OPTIONAL_PACKAGES "ParMETIS")
list(APPEND OPTIONAL_PACKAGES "SUNDIALS")
list(APPEND OPTIONAL_PACKAGES "zlib")
list(APPEND OPTIONAL_PACKAGES "HDF5")

# Add options
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "DOLFIN_ENABLE_${OPTIONAL_PACKAGE}" OPTION_NAME)
  option(${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}." ON)
  add_feature_info(${OPTION_NAME} ${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}.")
endforeach()

#------------------------------------------------------------------------------
# Package-specific options

# None at the moment

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-pipe ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Add some strict compiler checks
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-Wall -Werror -pedantic ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Debug flags
CHECK_CXX_COMPILER_FLAG(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-g ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

CHECK_CXX_COMPILER_FLAG(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-O2 ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Set 'Developer' build type flags
set(CMAKE_CXX_FLAGS_DEVELOPER "${DOLFIN_CXX_DEVELOPER_FLAGS}" CACHE STRING
  "Flags used by the compiler during development." FORCE)

# Add flags for generating code coverage reports
if (DOLFIN_ENABLE_CODE_COVERAGE AND CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

# Settings for Intel compilers
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # Use -isystem incluse flag with Intel compiler
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")

  # Stop spurious warnings from older Intel compilers
  if("${CMAKE_CXX_COMPILER_VERSION}" LESS "13")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd654,1125")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -wd654,1125")
    set(CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER} -wd654,1125")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -wd654,1125")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -wd654,1125")
  endif()
endif()

# Set system include flags to get around CMake bug on OSX with gcc See
# http://public.kitware.com/Bug/print_bug_page.php?bug_id=10837
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
endif()

if (APPLE)
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
  set(CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER} -Wno-long-long")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-long-long")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -Wno-long-long")
endif()

#------------------------------------------------------------------------------
# Check for MPI

# FIXME: Should be set CMake to use the MPI compiler wrappers?

if (DOLFIN_ENABLE_MPI)
  if (DOLFIN_AUTO_DETECT_MPI)
    find_package(MPI)
    set_package_properties(MPI PROPERTIES TYPE OPTIONAL
      DESCRIPTION "Message Passing Interface (MPI)"
      PURPOSE "Enables DOLFIN to run in parallel with MPI")
  else()
    # Assume user has set MPI compiler wrappers (via CXX, etc or
    # CMAKE_CXX_COMPILER, etc)
    set(MPI_CXX_FOUND TRUE)
    set(MPI_C_FOUND TRUE)
  endif()
endif()

#------------------------------------------------------------------------------
# Run tests to find required packages

# Check for Boost
set(BOOST_ROOT $ENV{BOOST_DIR} $ENV{BOOST_HOME})
if (BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS on)
endif()

# Prevent FindBoost.cmake from looking for system Boost{foo}.cmake
# files
set(Boost_NO_BOOST_CMAKE true)

set(Boost_USE_MULTITHREADED $ENV{BOOST_USE_MULTITHREADED})
find_package(Boost 1.56 QUIET REQUIRED)

# Boost public/private libraries to link to.
# Note: These should all be private as they do not appear in the
# DOLFIN public interface , but there is a linking issues with older
# Boost or CMake. Ubuntu 16.04 requires linking DOLFIN programs with
# filesystem, whereas Ubuntu 16.10 and macOS (Homebrew) do not.
if (Boost_VERSION VERSION_LESS 106100)
  set(DOLFIN_BOOST_COMPONENTS_PUBLIC filesystem timer)
  set(DOLFIN_BOOST_COMPONENTS_PRIVATE program_options iostreams)
else()
  set(DOLFIN_BOOST_COMPONENTS_PUBLIC timer)
  set(DOLFIN_BOOST_COMPONENTS_PRIVATE filesystem program_options iostreams)
endif()

# Find required Boost libraries
find_package(Boost COMPONENTS
  ${DOLFIN_BOOST_COMPONENTS_PUBLIC} ${DOLFIN_BOOST_COMPONENTS_PRIVATE} REQUIRED)
set_package_properties(Boost PROPERTIES TYPE REQUIRED
  DESCRIPTION "Boost C++ libraries"
  URL "http://www.boost.org")

# Check for required package Eigen3
find_package(Eigen3 3.2.90 REQUIRED)
set_package_properties(Eigen3 PROPERTIES TYPE REQUIRED
  DESCRIPTION "Lightweight C++ template library for linear algebra"
  URL "http://eigen.tuxfamily.org")

#------------------------------------------------------------------------------
# Run tests to find optional packages

# Is this still needed?
find_package(PythonInterp 3)

set_package_properties(PythonInterp PROPERTIES TYPE REQUIRED
  DESCRIPTION "Interactive high-level object-oriented language"
  URL "http://www.python.org")

# Check for required package UFC
find_package(UFC MODULE ${DOLFIN_VERSION_MAJOR}.${DOLFIN_VERSION_MINOR})
set_package_properties(UFC PROPERTIES TYPE REQUIRED
  DESCRIPTION "Unified language for form-compilers (part of FFC)"
  URL "https://bitbucket.org/fenics-project/ffc")

# Check for PETSc and SLEPc
set(PETSC_FOUND FALSE)

=== demo/CMakeLists.txt ===
project(dolfin-demos)

# Require CMake 2.8
cmake_minimum_required(VERSION 3.5)

# Find DOLFIN config file (not used here, but check that the demo will
# be able to find it
#find_package(DOLFIN PATHS ${CMAKE_BINARY_DIR} REQUIRED)

# Documented demos
add_subdirectory(documented/auto-adaptive-poisson/cpp)
add_subdirectory(documented/bcs/cpp)
add_subdirectory(documented/biharmonic/cpp)
add_subdirectory(documented/built-in-meshes/cpp)
add_subdirectory(documented/cahn-hilliard/cpp)
add_subdirectory(documented/eigenvalue/cpp)
add_subdirectory(documented/hyperelasticity/cpp)
add_subdirectory(documented/mixed-poisson/cpp)
add_subdirectory(documented/navier-stokes/cpp)
add_subdirectory(documented/neumann-poisson/cpp)
add_subdirectory(documented/nonlinear-poisson/cpp)
add_subdirectory(documented/nonmatching-interpolation/cpp)
add_subdirectory(documented/periodic/cpp)
add_subdirectory(documented/poisson/cpp)
add_subdirectory(documented/singular-poisson/cpp)
add_subdirectory(documented/stokes-iterative/cpp)
add_subdirectory(documented/stokes-taylor-hood/cpp)
add_subdirectory(documented/subdomains/cpp)

# Undocumented demos
add_subdirectory(undocumented/advection-diffusion/cpp)
add_subdirectory(undocumented/ale/cpp)
add_subdirectory(undocumented/auto-adaptive-navier-stokes/cpp)
add_subdirectory(undocumented/block-matrix/cpp)
add_subdirectory(undocumented/conditional/cpp)
add_subdirectory(undocumented/contact-vi-snes/cpp)
add_subdirectory(undocumented/contact-vi-tao/cpp)
add_subdirectory(undocumented/curl-curl/cpp)
add_subdirectory(undocumented/dg-advection-diffusion/cpp)
add_subdirectory(undocumented/dg-poisson/cpp)
add_subdirectory(undocumented/elasticity/cpp)
add_subdirectory(undocumented/elastodynamics/cpp)
add_subdirectory(undocumented/eval/cpp)
add_subdirectory(undocumented/extrapolation/cpp)
add_subdirectory(undocumented/functional/cpp)
add_subdirectory(undocumented/gmg-poisson/cpp)
add_subdirectory(undocumented/lift-drag/cpp)
add_subdirectory(undocumented/mesh-quality/cpp)
add_subdirectory(undocumented/meshfunction-refinement/cpp)
add_subdirectory(undocumented/multimesh-poisson/cpp)
add_subdirectory(undocumented/multimesh-stokes/cpp)
add_subdirectory(undocumented/nonmatching-projection/cpp)
add_subdirectory(undocumented/parallel-refinement/cpp)
add_subdirectory(undocumented/parameters/cpp)
add_subdirectory(undocumented/poisson1D/cpp)
add_subdirectory(undocumented/poisson1D-in-2D/cpp)
add_subdirectory(undocumented/poisson-disc/cpp)
add_subdirectory(undocumented/refinement/cpp)
add_subdirectory(undocumented/spatial-coordinates/cpp)
add_subdirectory(undocumented/submesh/cpp)
add_subdirectory(undocumented/sym-dirichlet-bc/cpp)
add_subdirectory(undocumented/time-series/cpp)
add_subdirectory(undocumented/waveguide/cpp)

=== dolfin/la/CMakeLists.txt ===
set(HEADERS
  Amesos2LUSolver.h
  BelosKrylovSolver.h
  BlockMatrix.h
  BlockVector.h
  CoordinateMatrix.h
  DefaultFactory.h
  dolfin_la.h
  EigenFactory.h
  EigenKrylovSolver.h
  EigenLUSolver.h
  EigenMatrix.h
  EigenVector.h
  GenericLinearAlgebraFactory.h
  GenericLinearOperator.h
  GenericLinearSolver.h
  GenericMatrix.h
  GenericTensor.h
  GenericVector.h
  Ifpack2Preconditioner.h
  IndexMap.h
  KrylovSolver.h
  LinearAlgebraObject.h
  LinearOperator.h
  LinearSolver.h
  LUSolver.h
  Matrix.h
  MueluPreconditioner.h
  PETScBaseMatrix.h
  PETScFactory.h
  PETScKrylovSolver.h
  PETScLinearOperator.h
  PETScLUSolver.h
  PETScMatrix.h
  PETScObject.h
  PETScOptions.h
  PETScPreconditioner.h
  PETScVector.h
  Scalar.h
  SLEPcEigenSolver.h
  solve.h
  SparsityPattern.h
  SUNDIALSNVector.h
  TensorLayout.h
  test_nullspace.h
  TpetraFactory.h
  TpetraMatrix.h
  TpetraVector.h
  TrilinosParameters.h
  TrilinosPreconditioner.h
  Vector.h
  VectorSpaceBasis.h
  PARENT_SCOPE)

set(SOURCES
  Amesos2LUSolver.cpp
  BelosKrylovSolver.cpp
  BlockMatrix.cpp
  BlockVector.cpp
  CoordinateMatrix.cpp
  DefaultFactory.cpp
  EigenFactory.cpp
  EigenKrylovSolver.cpp
  EigenLUSolver.cpp
  EigenMatrix.cpp
  EigenVector.cpp
  GenericLinearSolver.cpp
  GenericMatrix.cpp
  Ifpack2Preconditioner.cpp
  IndexMap.cpp
  KrylovSolver.cpp
  LinearOperator.cpp
  LinearSolver.cpp
  LUSolver.cpp
  MueluPreconditioner.cpp
  PETScBaseMatrix.cpp
  PETScFactory.cpp
  PETScKrylovSolver.cpp
  PETScLinearOperator.cpp
  PETScLUSolver.cpp
  PETScMatrix.cpp
  PETScObject.cpp
  PETScOptions.cpp
  PETScPreconditioner.cpp
  PETScVector.cpp
  SLEPcEigenSolver.cpp
  solve.cpp
  SparsityPattern.cpp
  TensorLayout.cpp
  test_nullspace.cpp
  TpetraFactory.cpp
  TpetraMatrix.cpp
  TpetraVector.cpp
  TrilinosParameters.cpp
  VectorSpaceBasis.cpp
  PARENT_SCOPE)

=== dolfin/ts/CMakeLists.txt ===
set(HEADERS
  dolfin_ts.h
  CVode.h
  PARENT_SCOPE)

set(SOURCES
  CVode.cpp
  PARENT_SCOPE)

=== test/unit/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(dolfin-tests)

find_package(DOLFIN REQUIRED)
include(${DOLFIN_USE_FILE})

# Prepare "Catch" library for other executables
set(CATCH_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/catch)

add_library(Catch INTERFACE)
target_include_directories(Catch INTERFACE ${CATCH_INCLUDE_DIR})

# Make test executable
set(TEST_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/common/SubSystemsManager.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/function/Expression.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/geometry/ConvexTriangulation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/geometry/IntersectionConstruction.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/io/XMLMeshData.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/io/XMLMeshValueCollection.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/la/LinearOperator.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/la/Vector.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/Mesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MeshColoring.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MeshFunction.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MeshValueCollection.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MultiMesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/parameter/Parameters.cpp
  )

add_executable(unittests ${TEST_SOURCES})
target_link_libraries(unittests PRIVATE Catch dolfin)

# Test target
add_test(unittests unittests)

=== debian/changelog ===
dolfin (2018.1.0.post1-16) unstable; urgency=medium

  * use ctest --output-on-failure not -output-on-failure

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Feb 2019 19:14:25 +1100

dolfin (2018.1.0.post1-15) unstable; urgency=medium

  * symlink man-page for fenics-version to manpage for dolfin-version
  * run ctest with -output-on-failure to show details of test failures

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Feb 2019 13:58:33 +1100

dolfin (2018.1.0.post1-14) unstable; urgency=medium

  * add debian patch pytest_fixtures_096217a.patch
    (upstream commit 096217a0a3cb710e869d7e82a3d3609c4d968b76)
    to update tests for latest pytest API.
  * debhelper compatibility level 12
  * dolfin-bin installs /usr/bin/fenics-version
  * usr/share/dolfin/dolfin.conf is redundant on Debian,
    list it in debian/not-installed
  * debian/rules:
    - skip C++ build-time tests of demo_elastodynamics_mpi
      (unreliable, sometimes passes, but fails with pdebuild)
    - override dh_dwz to ignore python module .so files (already
      stripped by python's setuptools)

 -- Drew Parsons <dparsons@debian.org>  Sat, 09 Feb 2019 18:07:21 +1100

dolfin (2018.1.0.post1-13) unstable; urgency=medium

  * Standards-Version: 4.3.0
  * create patch PETSc_3.10_SNESTEST_removed.patch to work with
    PETSc 3.10 (SNESTEST has been removed). Thanks Jed Brown.

 -- Drew Parsons <dparsons@debian.org>  Wed, 26 Dec 2018 09:14:38 +0100

dolfin (2018.1.0.post1-12) unstable; urgency=medium

  * apply strict versioned depends on pybind11,
    python3-dolfin Depends: pybind11 (>= 2.2.4), pybind11 (<= 2.2.5)
    Closes: #909407.
  * Hardening: add dpkg-buildflags CXXFLAGS to CMAKE_CXX_FLAGS and
    python module build
  * use VERBOSE build of python modules

 -- Drew Parsons <dparsons@debian.org>  Mon, 24 Sep 2018 03:03:27 +0800

dolfin (2018.1.0.post1-11) unstable; urgency=medium

  * skip slow build-time tests (>500-1000 sec to complete)
  * rebuild for pybind11 2.2.4

 -- Drew Parsons <dparsons@debian.org>  Sun, 23 Sep 2018 04:58:48 +0800

dolfin (2018.1.0.post1-10) unstable; urgency=medium

  * skip build-time tests:
    - demo_auto-adaptive-poisson_serial test on m68k
    - demo_cahn-hilliard_mpi and other MPI tests on mips
    - all tests on sh4

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Sep 2018 03:53:23 +0800

dolfin (2018.1.0.post1-9) unstable; urgency=medium

  * autopkgtest: configure cpp tests with mpicc to ensure that the
    cmake test for PetscInt passes
  * Standards-Version: 4.2.1

 -- Drew Parsons <dparsons@debian.org>  Mon, 03 Sep 2018 04:17:35 +0800

dolfin (2018.1.0.post1-8) unstable; urgency=medium

  * mark libdolfin2018.1 as Multi-Arch: same
  * python3-dolfin Depends: python3-six
  * Standards-Version: 4.2.0

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Aug 2018 00:11:03 +0800

dolfin (2018.1.0.post1-7) unstable; urgency=medium

  * skip demo_stokes-taylor-hood_mpi test on mips64el

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 Aug 2018 22:54:05 +0800

dolfin (2018.1.0.post1-6) unstable; urgency=medium

  * skip demo_cahn-hilliard_mpi, demo_ale_mpi, demo_poisson-disc_mpi
    tests on mipsel
  * skip demo_elasticity_serial test on m68k
  * run build-time tests on mips, but skip demo_cahn-hilliard_serial,
    demo_hyperelasticity_serial

 -- Drew Parsons <dparsons@debian.org>  Tue, 31 Jul 2018 15:16:58 +0800

dolfin (2018.1.0.post1-5) unstable; urgency=medium

  * update debian/test (autopkgtest) Depends
  * skip demo_sym-dirichlet-bc_mpi test on ppc64el
  * skip ALL build-time tests on mips, hurd-i386

 -- Drew Parsons <dparsons@debian.org>  Sat, 28 Jul 2018 22:42:00 +0800

dolfin (2018.1.0.post1-4) unstable; urgency=medium

  * skip demo_bcs_mpi test on mips64el
  * update debian/tests/control Depends: @, @builddeps@
    (to provide c++)

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Jul 2018 14:47:32 +0800

dolfin (2018.1.0.post1-3) unstable; urgency=medium

  * update skipped tests:
    - skip demo_navier-stokes_mpi test on arm64
    - skip demo_contact-vi-tao_mpi on mips64el
    - skip demo_stokes-iterative_mpi on mipsel
    - skip all MPI tests on armhf, i386, hppa, powerpc
  * don't download fresh source for tests
  * do copy symlink contents for C++ tests (in particular, copy
    pulley.xdmf for demo_elasticity)
  * tests Depends: python3-pytest

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Jul 2018 02:42:56 +0800

dolfin (2018.1.0.post1-2) unstable; urgency=medium

  * new upstream version for unstable.
    Some minor API changes:
      - Rename `mpi_comm_world()` to `MPI.comm_world`.
      - Rename `ERROR`, `CRITICAL` etc. to `LogLevel.ERROR`,
        `LogLevel.CRITICAL`.
  * skip demo_curl-curl_mpi test on mips64el

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Jul 2018 01:19:42 +0800

dolfin (2018.1.0.post1-1exp6) experimental; urgency=medium

  * skip all MPI tests on ppc64el

 -- Drew Parsons <dparsons@debian.org>  Wed, 11 Jul 2018 10:39:00 +0800

dolfin (2018.1.0.post1-1exp5) experimental; urgency=medium

  * updates to debian/rules:
    - identify build dir using DEB_HOST_GNU_TYPE
    - respect the parallel flag in DEB_BUILD_OPTIONS when running tests
    - skip cahn-hilliard, elasticity, elastodynamics MPI build tests
      which fail or time out for: armel mips64el ppc64el
    - skip m68k MPI tests altogether (times out)
  * debian patch unittests_demos_include_dirs.patch ensures include
    directories are defined for tests without reconfiguring cmake
  * link elasticity/pulley.xdmf from python demo to cpp demo
  * allow parallel jobs (max 8) in CI test test-dolfin-cpp

 -- Drew Parsons <dparsons@debian.org>  Sun, 08 Jul 2018 13:14:48 +0800

dolfin (2018.1.0.post1-1exp4) experimental; urgency=medium

  * Enable installation CI testing with Testsuite: autopkgtest.
  * run build-time tests including unittests and demos
    - use --oversubscribe with openmpi tests
    - skip demo_hyperelasticity_mpi (it diverges)


=== debian/control ===
Source: dolfin
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Johannes Ring <johannr@simula.no>,
 Drew Parsons <dparsons@debian.org>
Build-Depends:
 cmake (>= 3.5),
 debhelper (>= 12),
 dh-python,
 gfortran,
 chrpath,
 libboost-chrono-dev,
 libboost-dev (>= 1.56),
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libeigen3-dev (>= 3.2.90),
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 mpi-default-dev,
 petsc-dev (>= 3.7),
 slepc-dev (>= 3.7),
 pybind11-dev (>= 2.2.0),
 python3-setuptools,
 python3-petsc4py,
 python3-slepc4py,
 pkg-config,
 python3-all-dev,
 python3-pkg-resources,
 python3-ffc (>= 2018.1), python3-ffc (<< 2018.2),
 python3-dijitso (>= 2018.1), python3-dijitso (<< 2018.2),
 python3-numpy,
 python3-ply
Standards-Version: 4.3.0
Homepage: http://fenicsproject.org
Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfin.git
Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfin

Package: libdolfin-dev
Section: libdevel
Architecture: any
Depends:
 cmake (>= 2.8.0),
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libdolfin2018.1 (= ${binary:Version}),
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 pkg-config,
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 ${petsc:Depends},
 ${misc:Depends}
Conflicts:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Replaces:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Description: Shared links and header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files.

Package: libdolfin2018.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfin-doc, python3-dolfin
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries.

Package: python3-dolfin
Section: python
Architecture: any
Depends:
 libdolfin-dev (= ${binary:Version}),
 libdolfin2018.1 (= ${binary:Version}),
 python3-dijitso (>= ${fenics:Upstream-Version}), python3-dijitso (<< ${fenics:Next-Upstream-Version}),
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 python3-ufl (>= ${fenics:Upstream-Version}), python3-ufl (<< ${fenics:Next-Upstream-Version}),
 python3-numpy,
 python3-ply,
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 python3-six,
 python3-sympy,
 ${python3-petsc4py:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Suggests: dolfin-doc
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3).

Package: python-dolfin
Section: python
Architecture: all
Depends:
 python3-dolfin (>= ${fenics:Upstream-Version}), ${misc:Depends}
Description: Python interface for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This is a dummy package that depends on python3-dolfin.
 (DOLFIN no longer supports Python 2).

Package: dolfin-doc
Architecture: all
Section: doc
Depends:
 libdolfin-dev (>= ${source:Version}),
 python3-dolfin (>= ${source:Version}),
 ${misc:Depends}
Suggests: cmake (>= 2.8.0)
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains documentation and demo programs for DOLFIN.

Package: dolfin-bin
Architecture: all
Depends:
 python3-dolfin (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends}
Description: Executable scripts for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains executable scripts for DOLFIN.

=== debian/rules ===
#!/usr/bin/make -f

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
FENICS_MINOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )

# dolfin has a strict dependency on the pybind11 version it was built against,
# if pybind11.h will be used in C++ code fragments in python scripts.
# Extract pybind11 version from pybind11-dev
PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
# extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
PYBIND11_Z_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\2/")
PYBIND11_NEXT_UPSTREAM_VERSION=$(PYBIND11_X_Y_VERSION).$(shell echo $$(( $(PYBIND11_Z_VERSION) + 1 )) )

# Allow test programs that uses OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)

include /usr/share/mpi-default-dev/debian_defaults
ENABLE_MPI=ON
ifeq ($(findstring $(DEB_BUILD_ARCH),$(OPENMPI_ARCHITECTURES)),)
MPIEXEC_PARAMS=
else
MPIEXEC_PARAMS=--oversubscribe
endif

DOLFIN_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS)

BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
TESTDIR = build-tests

NPROC := $(shell nproc)
PARALLEL = $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
N_CPU    = $(or $(PARALLEL),$(NPROC),1)
# MPI tests are set up to run on 3 processes. Spread them leanly over the available processors (don't have more than 2 tests using one processor).
# e.g. run 1 MPI test at a time over 1-3 processors, or 2 tests at a time over 4-6 processors, or 3 tests over 7-9 processors, etc.
N_MPI := 3
N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )

# hyperelasticity fails (diverges) on all arches (pivot factors too large, not enough memory assigned)
# elastodynamics passes with dpkg-buildpackage but fails with pdebuild (on amd64). Unreliable, so skip.
ARCH_ALL_SKIP_MPI_TEST = demo_hyperelasticity_mpi demo_elastodynamics_mpi

# Some arches fail the same MPI tests
# e.g. cahn-hilliard, navier-stokes, elasticity, fails or exceeds allowed time
# So skip these tests on the failing arches
ARCH_SKIP_MPI_TEST_LIST = i386 mips64el ppc64el
ARCH_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_navier-stokes_mpi demo_elasticity_mpi

# skip more MPI tests for some specific arches
ifeq (arm64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_navier-stokes_mpi
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (mips64el, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_bcs_mpi demo_stokes-iterative_mpi demo_stokes-taylor-hood_mpi demo_curl-curl_mpi demo_contact-vi-tao_mpi
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (ppc64el, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_poisson_mpi demo_singular-poisson_mpi demo_sym-dirichlet-bc_mpi
else
  ARCH_SPECIFIC_SKIP_MPI_TEST =
endif

# m68k and mips need some help to pass serial tests
ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_auto-adaptive-poisson_serial demo_elasticity_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else
  ARCH_SPECIFIC_SKIP_SERIAL_TEST =
endif

# skip slow tests (> 500-1000 sec to complete)
ifeq (armel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_stokes-iterative_serial demo_auto-adaptive-navier-stokes_serial demo_hyperelasticity_serial demo_cahn-hilliard_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_eigenvalue_serial demo_navier-stokes_serial demo_auto-adaptive-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_curl-curl_serial demo_elasticity_serial demo_stokes-iterative_serial demo_eval_serial demo_sym-dirichlet-bc_serial demo_elastodynamics_serial demo_eigenvalue_mpi demo_navier-stokes_mpi demo_curl-curl_mpi demo_elasticity_mpi demo_elastodynamics_mpi demo_sym-dirichlet-bc_mpi
else ifeq (mips64el, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (hppa, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (riscv64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_stokes-iterative_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else
  ARCH_SKIP_SLOW_TEST =
endif

# other arches fail or time out on too many tests, so skip all their MPI tests
ARCH_SKIP_ALL_MPI_TESTS_LIST=armel armhf i386 hppa m68k powerpc

# some arches just aren't keeping up at all, and fail non-MPI tests
ARCH_SKIP_ALL_TESTS_LIST = hurd-i386 m68k sh4

# extract PETSc version from petsc-dev
PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
# extract the current PETSc version
PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
# "Major" version is the first number in the upstream version (major.minor.release)
PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
# "Minor" version is the second number in the upstream version (major.minor.release)
PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
PETSC_VERSION=$(PETSC_MAJOR_VERSION).$(PETSC_MINOR_VERSION)
PETSC_VERSION_NEXT=$(shell echo $(PETSC_MAJOR_VERSION).$$(($(PETSC_MINOR_VERSION)+1)))

SLEPC_UPSTREAM_VERSION=$(shell pkg-config --modversion SLEPc)
# SLEPc version must match PETSc
SLEPC_VERSION=$(PETSC_VERSION)
SLEPC_VERSION_NEXT=$(PETSC_VERSION_NEXT)

PETSC_DIR=/usr/lib/petscdir/petsc$(PETSC_VERSION)/$(DEB_HOST_MULTIARCH)-real
SLEPC_DIR=/usr/lib/slepcdir/slepc$(SLEPC_VERSION)/$(DEB_HOST_MULTIARCH)-real


DEB_CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)

CMAKE_OPTS := \
	-D CMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D PETSC_DIR:PATH=$(PETSC_DIR) \
	-D SLEPC_DIR:PATH=$(SLEPC_DIR) \
	-D DOLFIN_ENABLE_TRILINOS:BOOL=OFF \
	-D DOLFIN_ENABLE_HDF5:BOOL=ON \
	-D HDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5pcc \
	-D DOLFIN_ENABLE_PARMETIS:BOOL=OFF \
	-D DOLFIN_ENABLE_SCOTCH:BOOL=ON \
	-D DOLFIN_ENABLE_DOCS:BOOL=OFF \
	-D DOLFIN_ENABLE_MPI:BOOL=$(ENABLE_MPI) \
	-D MPIEXEC_PARAMS:STRING="$(MPIEXEC_PARAMS)" \
	-D CMAKE_CXX_FLAGS:STRING="-fpermissive" \

=== debian/tests/control ===
Tests: test-dolfin-cpp, test-dolfin-python
Depends: @, @builddeps@,
	  python3-pytest,
	  python3-decorator,
	  python3-matplotlib,
	  python3-scipy
